from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework import permissions, status
from django.http import HttpRequest
from django.contrib.auth import login
from rest_framework.authentication import SessionAuthentication

from ..serializers.login import LoginSerializer

class LoggedView(APIView):
    
	permission_classes = (permissions.AllowAny,)
	authentication_classes = (SessionAuthentication,)

	def get(self, request: HttpRequest):
		return Response(str(request.user.is_authenticated), status=status.HTTP_200_OK)